/* Flex file for parsing PGC configuration files */
%{
  #include <stdio.h>
  #include <string.h>
  #include "pgc_conf_lexer.h"

%}

WS			[\040\t]
TXT			(([^\040\t\n\134\075])|(\134\075)|(\134\134))

%option noyywrap yylineno prefix="yy_conf" outfile="pgc_conf_lexer.c"
%s LEFT_SIDE FULCRUM RIGHT_SIDE
%%

<INITIAL>[{WS}\n]*
<INITIAL><<EOF>>	yyterminate ();
<INITIAL>{TXT}		{ unput (yytext[0]);
                          BEGIN (LEFT_SIDE); }
<INITIAL>"="+		return PGC_CONF_ERROR;

<LEFT_SIDE>{TXT}+	{ yylval.entry_name = strdup (yytext);
			  BEGIN (FULCRUM); }
<LEFT_SIDE><<EOF>>	return PGC_CONF_ERROR;
<LEFT_SIDE>\n+	        return PGC_CONF_ERROR;

<FULCRUM>{WS}*\={WS}*		BEGIN (RIGHT_SIDE);
<FULCRUM><<EOF>>		return PGC_CONF_ERROR;
<FULCRUM>(\n)+		return PGC_CONF_ERROR;

<RIGHT_SIDE>.*		{ yylval.entry_value = strdup (yytext);
			  return PGC_CONF_TOKEN; }
<RIGHT_SIDE>\n		BEGIN (INITIAL);
<RIGHT_SIDE><<EOF>>	{ unput (yytext[0]);
			  yylval.entry_value = strdup ("");
			  yyterminate (); }
%%
